Типограф на JavaScript
======================
<img align="right" width="200" src="https://avatars0.githubusercontent.com/u/10176019" />

[![NPM version](https://img.shields.io/npm/v/typograf.svg?style=flat)](https://www.npmjs.com/package/typograf)
[![NPM downloads](https://img.shields.io/npm/dm/typograf.svg?style=flat)](https://www.npmjs.com/package/typograf)
[![Build Status](https://img.shields.io/travis/typograf/typograf.svg?style=flat)](https://travis-ci.org/typograf/typograf)
[![Build Status](https://img.shields.io/appveyor/ci/hcodes/typograf/dev.svg?style=flat)](https://ci.appveyor.com/project/hcodes/typograf)
[![Coverage Status](https://img.shields.io/coveralls/typograf/typograf.svg?style=flat)](https://coveralls.io/r/typograf/typograf)
[![Dependency Status](https://img.shields.io/david/typograf/typograf.svg?style=flat)](https://david-dm.org/typograf/typograf)

Помогает автоматически расставить неразрывные пробелы, исправить мелкие опечатки, привести кавычки к правильному виду, заменить дефисы на тире в нужных местах и многое другое.

Попробуйте [типограф в действии](https://typograf.github.io).

## Черты:
 + гибкость и расширяемость;
 + UTF-8;
 + кроссплатформенность;
 + кроссбраузерность;
 + поддержка Node.js;
 + поддержка HTML;
 + [типографирование на лету](https://github.com/typograf/jquery-typograf);
 + TDD.

## Содержание
- [Использование](./docs/using.md)
- [Командный интерфейс](https://github.com/typograf/typograf-cli)
- [Дополнения для браузеров](https://github.com/red-typography/red-typography-webextension/)
  - [Google Chrome](https://chrome.google.com/webstore/detail/red-typography/dgmmkhdeghobfcedlnmgbncknnfjhnmo)
  - [Mozilla Firefox](https://addons.mozilla.org/ru/firefox/addon/typografy/)
  - [Opera и Яндекс.Браузер](https://addons.opera.com/ru/extensions/details/red-typography/)
- Плагины
  - [Visual Studio Code](https://marketplace.visualstudio.com/items?itemName=rusnasonov.vscode-typograf)
  - [Atom](https://atom.io/packages/red-typography)
  - [Grunt](https://github.com/typograf/grunt-typograf)
  - [Gulp](https://github.com/typograf/gulp-typograf)
  - [TinyMCE](https://habrahabr.ru/post/266337/)
- [Поддерживаемые правила](./docs/RULES.ru.md)
- API
  - [Включить или отключить правила](./docs/api_rules.md)
  - [Изменить настройку у правила](./docs/api_rules.md)
  - [Добавить простое правило](./docs/api_rules.md)
  - [Локализация](./docs/api_localization.md)
  - [HTML-сущности](./docs/api_entities.md)
  - [Неразрывные пробелы](./docs/api_nbsp.md)
  - [Отключение типографирования в участках текста](./docs/api_parts.md)
  - [Типографирование HTML-атрибутов](./docs/api_attrs.md)
  - [Висячая пунктуация](./docs/api_optalign.md)
  - [Типографика на лету](./docs/api_fly.md)
- [Сжатие с UglifyJS](./docs/uglifyjs.md)
- [Разработка](./docs/development.md)

## [Лицензия](./LICENSE.md)
MIT License

## Ссылки
+ [Средство поиска опечаток в текстах](https://github.com/hcodes/yaspeller)
+ [Восстановление буквы «ё» в русских текстах](https://github.com/hcodes/eyo)
